package simpletests.getattribute;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.beans.*;
import natinst.msl.datasocket.*;
import com.borland.jbcl.layout.*;
import com.borland.dx.dataset.Variant;

public class GetAttribute extends JFrame {
  JPanel contentPane;
  JButton connectButton;
  DataSocket dataSocket1;
  XYLayout xYLayout1 = new XYLayout();
  JButton disconnectButton = new JButton();
  JButton quitButton = new JButton();
  JTextField urlTextField = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextArea valueTextArea = new JTextArea();
  JLabel jLabel1 = new JLabel();
  JLabel statusLabel = new JLabel();
  JLabel jLabel4;
  JTextField attributeTextField;
  JButton getButton;
  JLabel jLabel5;

  //Construct the frame
  public GetAttribute() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    dataSocket1 = (DataSocket) Beans.instantiate(getClass().getClassLoader(), DataSocket.class.getName());
    contentPane = (JPanel) this.getContentPane();
    connectButton = (JButton) Beans.instantiate(getClass().getClassLoader(), JButton.class.getName());
    jLabel4 = (JLabel) Beans.instantiate(getClass().getClassLoader(), JLabel.class.getName());
    attributeTextField = (JTextField) Beans.instantiate(getClass().getClassLoader(), JTextField.class.getName());
    getButton = (JButton) Beans.instantiate(getClass().getClassLoader(), JButton.class.getName());
    jLabel5 = (JLabel) Beans.instantiate(getClass().getClassLoader(), JLabel.class.getName());
    contentPane.setLayout(xYLayout1);
    this.setSize(new Dimension(400, 350));
    this.setTitle("Get Attribute");
    connectButton.setText("Connect");
    connectButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        connectButton_actionPerformed(e);
      }
    });
    disconnectButton.setText("Disconnect");
    disconnectButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        disconnectButton_actionPerformed(e);
      }
    });
    quitButton.setText("Quit");
    quitButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        quitButton_actionPerformed(e);
      }
    });
    urlTextField.setText("dstp://localhost/data");
    jLabel2.setText("URL:");
    jLabel1.setText("Status:");
    jLabel4.setText("Attribute:");
    getButton.setText("Get");
    getButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        getButton_actionPerformed(e);
      }
    });
    jLabel5.setText("Value:");
    contentPane.add(statusLabel, new XYConstraints(73, 48, 283, 20));
    contentPane.add(urlTextField, new XYConstraints(72, 16, 273, -1));
    contentPane.add(jLabel2, new XYConstraints(13, 16, 48, 18));
    contentPane.add(jLabel1, new XYConstraints(12, 47, 55, 22));
    contentPane.add(connectButton, new XYConstraints(95, 75, -1, -1));
    contentPane.add(disconnectButton, new XYConstraints(210, 73, 102, 30));
    contentPane.add(attributeTextField, new XYConstraints(75, 118, 274, 23));
    contentPane.add(jLabel4, new XYConstraints(10, 118, 59, 23));
    contentPane.add(getButton, new XYConstraints(157, 152, 77, 31));
    contentPane.add(valueTextArea, new XYConstraints(64, 199, 272, 34));
    contentPane.add(jLabel5, new XYConstraints(7, 204, 48, 24));
    contentPane.add(quitButton, new XYConstraints(295, 257, -1, -1));
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void connectButton_actionPerformed(ActionEvent e) {
    dataSocket1.connectTo(urlTextField.getText(), DSAccessModes.cwdsReadAutoUpdate);

    dataSocket1.addDSOnDataUpdatedListener(new DSOnDataUpdatedListener() {
      public void DSOnDataUpdated(DSOnDataUpdatedEvent e) {
        dataSocket1_DSOnDataUpdated(e);
      }
    });

    dataSocket1.addDSOnStatusUpdatedListener(new DSOnStatusUpdatedListener() {
      public void DSOnStatusUpdated(DSOnStatusUpdatedEvent e) {
        dataSocket1_DSOnStatusUpdated(e);
      }
    });
  }

  public void dataSocket1_DSOnDataUpdated(DSOnDataUpdatedEvent e) {
    DSData dsData = dataSocket1.getData();
    valueTextArea.setText("");
    try {
      DSData attr = dsData.getAttribute(attributeTextField.getText());
      valueTextArea.setText(attr.getValueAsString());
    }
    catch (DSDataException y) {}
  }

  public void dataSocket1_DSOnStatusUpdated(DSOnStatusUpdatedEvent e) {
    statusLabel.setText(dataSocket1.getLastMessage());
  }

  void quitButton_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void disconnectButton_actionPerformed(ActionEvent e) {
    dataSocket1.disconnect();
  }

  void getButton_actionPerformed(ActionEvent e) {
    dataSocket1.update();
  }
}