package simpletests.getattributenames;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.beans.*;

import natinst.msl.datasocket.*;
import com.borland.jbcl.layout.*;
import com.borland.dx.dataset.Variant;

public class GetAttributeNames extends JFrame {
  JPanel contentPane;
  JButton connectButton;
  DataSocket dataSocket1;
  XYLayout xYLayout1 = new XYLayout();
  JButton disconnectButton = new JButton();
  JButton quitButton = new JButton();
  JTextField urlTextField = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextArea namesTextArea = new JTextArea();
  JLabel jLabel1 = new JLabel();
  JLabel statusLabel = new JLabel();
  JLabel jLabel4;
  JButton updateButton;

  //Construct the frame
  public GetAttributeNames() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    dataSocket1 = (DataSocket) Beans.instantiate(getClass().getClassLoader(), DataSocket.class.getName());
    contentPane = (JPanel) this.getContentPane();
    connectButton = (JButton) Beans.instantiate(getClass().getClassLoader(), JButton.class.getName());
    jLabel4 = (JLabel) Beans.instantiate(getClass().getClassLoader(), JLabel.class.getName());
    updateButton = (JButton) Beans.instantiate(getClass().getClassLoader(), JButton.class.getName());
    contentPane.setLayout(xYLayout1);
    this.setSize(new Dimension(403, 332));
    this.setTitle("Get Attribute Names");
    //contentPane.add(jTextField1, BorderLayout.CENTER);
    connectButton.setText("Connect");
    connectButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        connectButton_actionPerformed(e);
      }
    });
    disconnectButton.setText("Disconnect");
    disconnectButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        disconnectButton_actionPerformed(e);
      }
    });
    quitButton.setText("Quit");
    quitButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        quitButton_actionPerformed(e);
      }
    });
    urlTextField.setText("dstp://localhost/data");
    jLabel2.setText("URL:");
    jLabel1.setText("Status:");
    jLabel4.setText("Names:");
    updateButton.setText("Update");
    updateButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        updateButton_actionPerformed(e);
      }
    });
    contentPane.add(statusLabel, new XYConstraints(73, 48, 283, 20));
    contentPane.add(urlTextField, new XYConstraints(72, 16, 273, -1));
    contentPane.add(jLabel2, new XYConstraints(13, 16, 48, 18));
    contentPane.add(jLabel1, new XYConstraints(12, 47, 55, 22));
    contentPane.add(jLabel4, new XYConstraints(57, 119, 78, 23));
    contentPane.add(namesTextArea, new XYConstraints(56, 140, 272, 99));
    contentPane.add(quitButton, new XYConstraints(323, 255, -1, -1));
    contentPane.add(connectButton, new XYConstraints(47, 77, -1, -1));
    contentPane.add(updateButton, new XYConstraints(154, 78, -1, -1));
    contentPane.add(disconnectButton, new XYConstraints(252, 76, 102, 30));
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void connectButton_actionPerformed(ActionEvent e) {
    dataSocket1.connectTo(urlTextField.getText(), DSAccessModes.cwdsRead);

    dataSocket1.addDSOnDataUpdatedListener(new DSOnDataUpdatedListener() {
      public void DSOnDataUpdated(DSOnDataUpdatedEvent e) {
        dataSocket1_DSOnDataUpdated(e);
      }
    });

    dataSocket1.addDSOnStatusUpdatedListener(new DSOnStatusUpdatedListener() {
      public void DSOnStatusUpdated(DSOnStatusUpdatedEvent e) {
        dataSocket1_DSOnStatusUpdated(e);
      }
    });
  }

   public void dataSocket1_DSOnDataUpdated(DSOnDataUpdatedEvent e) {
    DSData dsData = dataSocket1.getData();
      String[] names = dsData.getAttributeNames();
      namesTextArea.setText("");
      for (int i = 0; i < names.length; i++)
      {
        namesTextArea.append(names[i]);
        namesTextArea.append("\n");
      }
  }

  public void dataSocket1_DSOnStatusUpdated(DSOnStatusUpdatedEvent e) {
    statusLabel.setText(dataSocket1.getLastMessage());
  }

  void quitButton_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void disconnectButton_actionPerformed(ActionEvent e) {
    dataSocket1.disconnect();
  }

  void updateButton_actionPerformed(ActionEvent e) {
    dataSocket1.update();
  }
}